-- DurabilityInfosWindow.lua
-- Written by Habna


SlotsBG = {"0x41007eed", "0x41007ef6", "0x41007ef7", "0x41007eef", "0x41007eee", "0x41007ee9", "0x41007ef0", "0x41007ef9", "0x41007ef8",
		"0x41007ef4", "0x41007ef3", "0x41007ef2", "0x41007ef1", "0x41007ef5", "0x41007efa", "0x41007eea", "0x41007eeb", "0x41007eec",
		"0x41007efb", "0x410e8680"};

SlotsText = {L["EWST1"], L["EWST2"], L["EWST3"], L["EWST4"], L["EWST5"], L["EWST6"], L["EWST7"], L["EWST8"], L["EWST9"],
		L["EWST10"], L["EWST11"], L["EWST12"], L["EWST13"], L["EWST14"], L["EWST15"], L["EWST16"], L["EWST17"],	L["EWST18"],
		L["EWST19"], L["EWST20"]};

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, mouseX, mouseY )
function ShowEIWindow()
	local x, y, w, h, bblTo = -5, -10, 592, 494, "left";
	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	
	if w + mouseX > screenWidth then bblTo = "right"; x = w - 10; end
	if not TBTop then y = h + 5; end
	TTW = CreateEIWindow( x, y, w, h, bblTo, mouseX, mouseY );
end

function CreateEIWindow( xOffset, yOffset, xSize, ySize, side, mX, mY )
	_G.ToolTipWin = Turbine.UI.Window();
	_G.ToolTipWin:SetSize( xSize, ySize );
	_G.ToolTipWin:SetZOrder( 1 );
	_G.ToolTipWin.xOffset = xOffset;
	_G.ToolTipWin.yOffset = yOffset;
	_G.ToolTipWin:SetPosition( mX - xOffset, mY - yOffset);
	_G.ToolTipWin:SetVisible( true );

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( _G.ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	topLeftCorner:SetBackground( resources.Bubble_TopLeftCorner.Background );
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( _G.ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, _G.ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( _G.ToolTipWin );
	botLeftCorner:SetPosition( 0, _G.ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( _G.ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( _G.ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( _G.ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( _G.ToolTipWin:GetWidth() - 15, _G.ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( _G.ToolTipWin );
	BotBar:SetPosition( 15, _G.ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( _G.ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( _G.ToolTipWin );
	topRightCorner:SetPosition( _G.ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	topRightCorner:SetBackground( resources.Bubble_TopRightCorner.Background );
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( _G.ToolTipWin );
	midRight:SetPosition( _G.ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, _G.ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( _G.ToolTipWin );
	botRightCorner:SetPosition( _G.ToolTipWin:GetWidth() - 15, _G.ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	
	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( _G.ToolTipWin );
	lblBackPack:SetText( L["DWLbl"] );
	lblBackPack:SetPosition( 15, 15);
	lblBackPack:SetSize( 350, 15 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblBackPack:SetForeColor( Color["green"] );

	lblBackPackD = Turbine.UI.Label();
	lblBackPackD:SetParent( _G.ToolTipWin );
	lblBackPackD:SetText( L["EWLblD"] );
	lblBackPackD:SetSize( 80, 15 );
	lblBackPackD:SetPosition( _G.ToolTipWin:GetWidth() - lblBackPackD:GetWidth() - 15 , 15);
	lblBackPackD:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	lblBackPackD:SetForeColor( Color["green"] );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( _G.ToolTipWin );
	ListBoxBorder:SetPosition( lblBackPack:GetLeft(), lblBackPack:GetTop() + lblBackPack:GetHeight() + 5 );
	ListBoxBorder:SetSize( 562, 444 );
	ListBoxBorder:SetBackColor( Color["grey"] );
	ListBoxBorder:SetVisible( true );

	EIListBox = Turbine.UI.ListBox();
	EIListBox:SetParent( _G.ToolTipWin );
	EIListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	EIListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	EIListBox:SetMaxItemsPerLine( 6 );
	EIListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	EIListBox:SetBackColor( Color["black"] );

	EIRefreshListBox();

	return _G.ToolTipWin;
end

function EIRefreshListBox()
	local EIitemCtl = {};
	--local EIitemEquipment = {};
	local EIitemLbl = {};
	local EIitemLblScore = {};
	local EIitemBG, EIitemU, EIitemS, EIitem = {}, {}, {}, {};
	EIListBox:ClearItems();
	
	for i = 1, 20 do
		-- Item background
		EIitemCtl[i] = Turbine.UI.Control();
		EIitemCtl[i]:SetSize( 44, 44 );
		EIitemCtl[i]:SetBackground( tonumber(SlotsBG[i]) );
		EIitemCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Item Background/Underlay/Shadow/Item
		EIitemBG[i] = Turbine.UI.Control();
		EIitemBG[i]:SetParent( EIitemCtl[i] );
		EIitemBG[i]:SetSize( 32, 32 );
		EIitemBG[i]:SetPosition( 6, 6 );
		EIitemBG[i]:SetBackground(itemEquip[i].QImgID);
		EIitemBG[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
		EIitemU[i] = Turbine.UI.Control();
		EIitemU[i]:SetParent( EIitemCtl[i] );
		EIitemU[i]:SetSize( 32, 32 );
		EIitemU[i]:SetPosition( 6, 6 );
		EIitemU[i]:SetBackground(itemEquip[i].UImgID);
		EIitemU[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		EIitemS[i] = Turbine.UI.Control();
		EIitemS[i]:SetParent( EIitemCtl[i] );
		EIitemS[i]:SetSize( 32, 32 );
		EIitemS[i]:SetPosition( 6, 6 );
		EIitemS[i]:SetBackground(itemEquip[i].SImgID);
		EIitemS[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		EIitem[i] = Turbine.UI.Control();
		EIitem[i]:SetParent( EIitemCtl[i] );
		EIitem[i]:SetSize( 32, 32 );
		EIitem[i]:SetPosition( 6, 6 );
		EIitem[i]:SetBackground(itemEquip[i].IImgID);
		EIitem[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		--[[
		EIitemEquipment[i] = itemEquip[i];
		EIitemEquipment[i]:SetPosition( 3, 3 );
		EIitemEquipment[i]:SetParent( EIitemCtl[i] );
		]]
		
		-- Item name
		EIitemLbl[i] = Turbine.UI.Label();
		EIitemLbl[i]:SetSize( 205, EIitemCtl[i]:GetHeight() );
		EIitemLbl[i]:SetFont(Turbine.UI.Lotro.Font.TrajanPro12 );
		EIitemLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		--EIitemLbl[i]:SetForeColor( Color["white"] );
		
		if itemEquip[i].Item == false then 
			EIitemLbl[i]:SetForeColor( Color["red"] );
			EIitemLbl[i]:SetText( SlotsText[i] .. ":\n" .. L["EWItemNP"] );
		else
			EIitemLbl[i]:SetText( SlotsText[i] .. ":\n" .. itemEquip[i].Name );
		end

		-- Item Score
		EIitemLblScore[i] = Turbine.UI.Label();
		EIitemLblScore[i]:SetText( itemEquip[i].ItemPts );
		EIitemLblScore[i]:SetSize( 30, EIitemCtl[i]:GetHeight() );
		EIitemLblScore[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		EIitemLblScore[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		
		-- Show item
		EIListBox:AddItem( EIitemCtl[i] );
		EIListBox:AddItem( EIitemLbl[i] );
		EIListBox:AddItem( EIitemLblScore[i] );
	end
end