-- functionsCtr.lua
-- Written By Habna


function ImportCtr( value )
	if value == "MI" then --Money Infos
		import (AppCtrD.."MoneyInfos");
		import (AppCtrD.."MoneyInfosToolTip");
		PlayerAtt = Player:GetAttributes();
		AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		UpdateMoney();
		MI["Ctr"]:SetPosition( _G.MILocX, _G.MILocY );
	elseif value == "DP" then --Destiny Points
		import (AppCtrD.."DestinyPoints");
		PlayerAtt = Player:GetAttributes();
		AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		UpdateDestinyPoints();
		DP["Ctr"]:SetPosition( _G.DPLocX, _G.DPLocY );
	elseif value == "SP" then --Shards
		import (AppCtrD.."Shards");
		LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Shard"];
		--AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateShards(); end);
		UpdateShards();
		SP["Ctr"]:SetPosition( _G.SPLocX, _G.SPLocY );
	elseif value == "SM" then --Skirmish Marks
		import (AppCtrD.."SkirmishMarks");
		LoadPlayerWallet();
		--PlayerMark = PlayerCurrency["Mark"];
		--AddCallback(PlayerMark, "QuantityChanged", function(sender, args) UpdateMarks(); end);
		UpdateMarks();
		SM["Ctr"]:SetPosition( _G.SMLocX, _G.SMLocY );
	elseif value == "MP" then --Medallions
		import (AppCtrD.."Medallions");
		LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Medallion"];
		--AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateMedallions(); end);
		UpdateMedallions();
		MP["Ctr"]:SetPosition( _G.MPLocX, _G.MPLocY );
	elseif value == "SL" then --Seals
		import (AppCtrD.."Seals");
		LoadPlayerWallet();
		--PlayerSeals = PlayerCurrency["Seals"];
		--AddCallback(PlayerSeals, "QuantityChanged", function(sender, args) UpdateSeals(); end);
		UpdateSeals();
		SL["Ctr"]:SetPosition( _G.SLLocX, _G.SLLocY );
	elseif value == "CP" then --Commendations
		import (AppCtrD.."Commendations");
		LoadPlayerWallet();
		--PlayerCommendation = PlayerCurrency["Commendation"];
		--AddCallback(PlayerCommendation, "QuantityChanged", function(sender, args) UpdateCommendations(); end);
		UpdateCommendations();
		CP["Ctr"]:SetPosition( _G.CPLocX, _G.CPLocY );
	elseif value == "BI" then --Backpack Infos
		import (AppCtrD.."BagInfos");
		Backpack = Player:GetBackpack();
		AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		AddCallback(Backpack, "ItemRemoved", function(sender, args) ItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround
		--AddCallback(Backpack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		UpdateBackpackInfos();
		BI["Ctr"]:SetPosition( _G.BILocX, _G.BILocY );
	elseif value == "PI" then --Player Infos
		import (AppCtrD.."PlayerInfos");
		import (AppCtrD.."PlayerInfosToolTip");
		AddCallback(Player, "LevelChanged", function(sender, args) PI["Lvl"]:SetText( Player:GetLevel() ); end);
		AddCallback(Player, "NameChanged", function(sender, args) PI["Name"]:SetText( Player:GetName() ); end);
		UpdatePlayersInfos();
		PI["Ctr"]:SetPosition( _G.PILocX, _G.PILocY );
	elseif value == "DI" then --Durability Infos
		import (AppCtrD.."DurabilityInfos");
		import (AppCtrD.."DurabilityInfosToolTip");
		UpdateDurabilityInfos();
		DI["Ctr"]:SetPosition( _G.DILocX, _G.DILocY );
	elseif value == "EI" then --Equipment Infos
		import (AppCtrD.."EquipInfos");
		import (AppCtrD.."EquipInfosToolTip");
		AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) UpdateEquipsInfos(); end);
		AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ItemUnEquippedTimer:SetWantsUpdates( true ); end); --Workaround
		--AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) UpdateEquipsInfos(); end);
		UpdateEquipsInfos();
		EI["Ctr"]:SetPosition( _G.EILocX, _G.EILocY );
	elseif value == "PL" then --Player Location
		import (AppCtrD.."PlayerLoc");
		AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			sMess = args.Message;

			----                1111111111222222222233333333 
			----       1234567890123456789012345678901234567
			--sMess = "Entered the Bree-town - Trade channel";

			if sMess ~= nil then
				if GLocale == "en" then sE, sC, iE = "Entered", "-%s", 13;
				elseif GLocale == "fr" then sE, sC, iE = "Canal", "-%s", 7;
				elseif GLocale == "de" then sE, sC, iE = "Kanal", "-%s", 13; end

				local bFound = string.find(sMess, sE, 1);
				if bFound ~= nil then
					local iLoc = string.find(sMess, sC, 1);
					if iLoc ~= nil then
						-- Extract Location from args.Message
						pLLoc = string.sub( sMess, iE, iLoc - 2 );
						UpdatePlayerLoc( pLLoc );
						settings.PlayerLoc.L = pLLoc;
						SaveSettings( false );
					end
				end
			end
		end);
		--PLoc = L["PLMsg"];
		UpdatePlayerLoc( pLLoc );
		PL["Ctr"]:SetPosition( _G.PLLocX, _G.PLLocY );
	elseif value == "GT" then --Game Time
		import (AppCtrD.."GameTime");
		--PlayerTime = Turbine.Engine.GetDate();
		--AddCallback(PlayerTime, "MinuteChanged", function(sender, args) UpdateGameTime(); end);
		if _G.ShowBT then UpdateGameTime("bt");
		elseif _G.ShowST then UpdateGameTime("st");
		else UpdateGameTime("gt") end
		GT["Ctr"]:SetPosition( _G.GTLocX, _G.GTLocY );
	end
end

function GetEquipmentInfos()
	LoadEquipmentTable();

	PlayerEquipment = Player:GetEquipment();
	if PlayerEquipment == nil then return end --Remove when Player Equipment info are available before plugin is loaded

	--itemEquipHandler = {};
	itemEquip = {};
	itemsTotDurability, itemTotScore, numItems = 0, 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item Name, WearState, Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = PlayerEquipItem:GetName();
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
			itemEquip[i].Item = true;

			--itemEquip[i].BGIcon = PlayerEquipItem:GetBackgroundImageID();  --Same as GetQualityImageID !?!?
			itemEquip[i].QImgID = PlayerEquipItem:GetQualityImageID();
			itemEquip[i].UImgID = PlayerEquipItem:GetUnderlayImageID();
			itemEquip[i].SImgID = PlayerEquipItem:GetShadowImageID();
			itemEquip[i].IImgID = PlayerEquipItem:GetIconImageID();

			WearState = PlayerEquipItem:GetWearState();
			itemEquip[i].WearState = WearState;
			if WearState ~= 0 then numItems = numItems + 1; end -- Undefined item must not be count (Pocket item are as Undefined Wear State, they are indestructible)

			if itemEquip[i].wsHandler == nil then itemEquip[i].wsHandler = AddCallback(PlayerEquipItem, "WearStateChanged", function(sender, args) ChangeWearState(i); end); end
			--if itemEquip[i].ieHandler == nil then itemEquip[i].ieHandler = AddCallback(PlayerEquipItem, "ItemEquipped", function(sender, args) UpdateEquipsInfos(i); end); end --Add when each item can trigger this event
			--if itemEquip[i].iuHandler == nil then itemEquip[i].iuHandler = AddCallback(PlayerEquipItem, "ItemUnequipped", function(sender, args) UpdateEquipsInfos(i); end); end --Add when each item can trigger this event
		else
			itemEquip[i].Name = "zEmpty";
			itemEquip[i].WearState = 0;
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
			itemEquip[i].Item = false;
		end
	end
end

function CalculateAllItemsDurability()
	local itemDurability = 0;
	itemsTotDurability = 0;

	for i = 1, 20 do
		-- Item Wear State
		if itemEquip[i].WearState == 0 then itemDurability = 0; end -- undefined
		if itemEquip[i].WearState == 2 then itemDurability = 100; end -- Pristine / parfait
		if itemEquip[i].WearState == 4 then itemDurability = 75; end -- Worn / us
		if itemEquip[i].WearState == 1 then itemDurability = 50; end -- Damaged / endommag
		if itemEquip[i].WearState == 3 then itemDurability = 0; end -- Broken / cass

		itemEquip[i].ItemDurPts = itemDurability;
		itemsTotDurability = itemsTotDurability + itemDurability;
	end

	itemsTotDurability = itemsTotDurability / numItems;
end

function CalculateAllItemsScore()
	local itemScore = 0;
	itemTotScore = 0;

	for i = 1, 20 do
		-- Item Score from it's Quality & Durability
		if itemEquip[i].Quality == 5 then itemScore = 50; end -- Common
		if itemEquip[i].Quality == 4 then itemScore = 100; end -- Uncommon
		if itemEquip[i].Quality == 3 then itemScore = 150; end -- Incomparable
		if itemEquip[i].Quality == 2 then itemScore = 200; end -- Rare
		if itemEquip[i].Quality == 1 then itemScore = 250; end -- Legendary
		if itemEquip[i].Quality == 0 then itemScore = 0; end -- undefined
		
		if itemEquip[i].Durability == 0 then itemScore = itemScore + 0; end -- undefined
		if itemEquip[i].Durability == 7 then itemScore = itemScore + 5; end -- Weak / Faible
		if itemEquip[i].Durability == 1 then itemScore = itemScore + 10; end -- Substantial
		if itemEquip[i].Durability == 2 then itemScore = itemScore + 20; end -- Brittle / Fragile
		if itemEquip[i].Durability == 3 then itemScore = itemScore + 30; end -- Normal
		if itemEquip[i].Durability == 4 then itemScore = itemScore + 40; end -- Tought / Robuste
		if itemEquip[i].Durability == 5 then itemScore = itemScore + 50; end -- Flimsy / Fragile ??
		if itemEquip[i].Durability == 6 then itemScore = itemScore + 60; end -- Indestructible
		
		itemEquip[i].ItemPts = itemScore;
		itemTotScore = itemTotScore + itemScore;
	end
end

function LoadPlayerMoney()
	OldWallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarWallet" );

	wallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarPlayerWallet" );

	if wallet == nil then
		wallet = {};

		if OldWallet ~= nil then
			--Convert old user settings to new format
			for k,v in pairs(OldWallet) do -- k: key / v: value
				if string.sub( k, 1, 1 ) ~= "~" then --Ignore session play character
					-- Extract gold/silver/copper from string v
					local pos1 = string.find(v, "/", 0);
					local pos2 = string.find(v, "/", pos1 + 1);
			
					local OldUSerGold = string.sub(v, 1, pos1 - 1);
					local OldUSerSilver = string.sub(v, pos1 + 1, pos2 - 1);
					local OldUSerCopper = string.sub(v, pos2 + 1, string.len(v));

					wallet[k] = {};
					wallet[k].Gold = OldUSerGold;
					wallet[k].Silver = OldUSerSilver;
					wallet[k].Copper = OldUSerCopper;
					if k ~= "Total" then wallet[k].Show = true; end
				end
			end
		end
	end

	local PN = Player:GetName();
	if wallet[PN] == nil then wallet[PN] = {}; end
	if wallet[PN].Show == nil then wallet[PN].Show = true; end
	if wallet[PN].ShowToAll == nil then wallet[PN].ShowToAll = true; end
	_G.SCM = wallet[PN].Show;
	_G.SCMA = wallet[PN].ShowToAll;
end

-- **v Save character wallet infos v**
function SaveCharacterMoney()
	local PN = Player:GetName();
	
	if string.sub( PN, 1, 1 ) == "~" then return end; --Ignore session play character

	wallet[PN].Gold = MI["GLbl"]:GetText();
	wallet[PN].Silver = MI["SLbl"]:GetText();
	wallet[PN].Copper = MI["CLbl"]:GetText();
	wallet[PN].Show = _G.SCM;
	wallet[PN].ShowToAll = _G.SCMA;
	
	if wallet.Total == nil then wallet.Total = {}; end
	GoldTot, SilverTot, CopperTot = 0, 0, 0;
	
	for k,v in pairs(wallet) do
		if k ~= "Total" then
			if k == PN then
				if v.Show then
					local Gold = v.Gold;
					GoldTot = GoldTot + Gold;

					local Silver = v.Silver;
					SilverTot = SilverTot + Silver;

					local Copper = v.Copper;
					CopperTot = CopperTot + Copper;
				end
			else
				if v.ShowToAll or v.ShowToAll == nil then
					local Gold = v.Gold;
					GoldTot = GoldTot + Gold;

					local Silver = v.Silver;
					SilverTot = SilverTot + Silver;

					local Copper = v.Copper;
					CopperTot = CopperTot + Copper;
				end
			end
		end
	end

	--************************************************************************
	if (string.len(CopperTot)==3) then
		local CopperTotX = CopperTot;
		SilverTot = SilverTot + string.sub(CopperTotX,1,-3);
		CopperTot = string.sub(CopperTot,2,-1);
	end
		
	if (string.len(SilverTot)==4) then
		local SilverTotX = SilverTot;
		GoldTot = GoldTot + string.sub(SilverTotX,1,-4);
		SilverTot = string.sub(SilverTot,2,-1);
	end
	--************************************************************************

	wallet.Total.Gold = string.format("%.0f", GoldTot)
	wallet.Total.Silver = string.format("%.0f", SilverTot)
	wallet.Total.Copper = string.format("%.0f", CopperTot)
	
	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarPlayerWallet", wallet );
end
-- **^

function LoadPlayerWallet()
	PlayerWallet = Player:GetWallet();
	PlayerWalletSize = PlayerWallet:GetSize();
	--write(tostring(PlayerWalletSize));
	if PlayerWalletSize == 0 then return end --Remove when Wallet info are available before plugin is loaded
	
	for i = 1, PlayerWalletSize do
		local CurItem = PlayerWallet:GetItem(i);
		local CurName = PlayerWallet:GetItem(i):GetName();

		PlayerCurrency[CurName] = CurItem;
		if PlayerCurrencyHandler[CurName] == nil then PlayerCurrencyHandler[CurName] = AddCallback(PlayerCurrency[CurName], "QuantityChanged", function(sender, args) UpdateCurrency(CurName); end); end
	end
end

function UpdateCurrency(str)
	if str == pwShard and ShowShards then UpdateShards(); end
	if str == pwMark and ShowSkirmishMarks then UpdateMarks(); end
	if str == pwMedallion and ShowMedallions then UpdateMedallions(); end
	if str == pwSeal and ShowSeals then UpdateSeals(); end
	if str == pwCommendation and ShowCommendations then UpdateCommendations(); end
end

function GetCurrency(str)
	CurQuantity = 0;
	
	for k,v in pairs(PlayerCurrency) do
		if k == str then
			CurQuantity = PlayerCurrency[str]:GetQuantity();
			break
		end
	end
	
	return CurQuantity
end