-- menu.lua
-- Written By Habna


-- Currency menu
local CURMenu = Turbine.UI.MenuItem( L["MBag"] );
CURMenu.Items = CURMenu:GetItems();

CurItem = {};
local MenuItem = {};
local MenuCheck = {};
local MenuFunction = {};

if PlayerAlign == 1 then
	MenuItem = { L["MGSC"], L["MDP"], L["MSP"], L["MSM"], L["MMP"], L["MSL"], L["MCP"] };
	MenuCheck = { ShowMoney, ShowDestinyPoints, ShowShards, ShowSkirmishMarks, ShowMedallions, ShowSeals, ShowCommendations };
	MenuFunction = { ShowHideMoney, ShowHideDestinyPoints, ShowHideShards, ShowHideSkirmishMarks, ShowHideMedallions, ShowHideSeals, ShowHideCommendations };
else
	-- Shard, Skirmish Marks & Medallion are available in wallet but is useless in Monster Play
	-- Only Money, Commendation & Infamy is usefull. (Money & Infamy not available in API)
	MenuItem = { L["MCP"] };
	MenuCheck = { ShowCommendations };
	MenuFunction = { ShowHideCommendations };
end

for i = 1, #MenuItem do
	CurItem[i] = Turbine.UI.MenuItem( MenuItem[i] );
	CurItem[i]:SetChecked( MenuCheck[i] );
	CurItem[i].Click = function( sender, args ) MenuFunction[i](i); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end
	CURMenu.Items:Add( CurItem[i] );
end

-- Locale menu
local LocMenu = Turbine.UI.MenuItem( L["MCL"] );
LocMenu.Items = LocMenu:GetItems();

local MenuItem = { L["MCLen"], L["MCLfr"], L["MCLde"] };
local Lang = { "en", "fr", "de" };

for i = 1, 3 do
	local LocItems = Turbine.UI.MenuItem( MenuItem[i] );
	if TBLocale == Lang[i] then LocItems:SetChecked( true ); end
	LocItems.Click = function( sender, args )
		--TBLocale = Lang[i];
		settings.TitanBar.L = Lang[i];
		SaveSettings( false );
		ReloadTitanBar();
	end
	
	LocMenu.Items:Add( LocItems );
end


-- Reset back color of... menu
local RBCMenu = Turbine.UI.MenuItem( L["MCRBG"] );
RBCMenu.Items = RBCMenu:GetItems();

local RBCMenu1 = Turbine.UI.MenuItem( L["MCABTTB"] );
RBCMenu1.Click = function( sender, args ) BGColor( "reset" , "TitanBar" ); end
RBCMenu.Items:Add( RBCMenu1 );

local RBCMenu2 = Turbine.UI.MenuItem( L["MCABTA"] );
RBCMenu2.Click = function( sender, args ) BGColor( "reset", "all" ); end
RBCMenu.Items:Add( RBCMenu2 );



--- Main menu
TitanBarMenu = Turbine.UI.ContextMenu();
TitanBarMenu.items = TitanBarMenu:GetItems();

local opt_line = Turbine.UI.MenuItem("---------------------------------------------", false);
local opt_empty = Turbine.UI.MenuItem("", false);

opt_BI = Turbine.UI.MenuItem(L["MBI"]);
opt_BI:SetChecked( ShowBagInfos );
opt_BI.Click = function( sender, args ) ShowHideBackpackInfos(); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_PI = Turbine.UI.MenuItem(L["MPI"]);
opt_PI:SetChecked( ShowPlayerInfos );
opt_PI.Click = function( sender, args ) ShowHidePlayerInfos(); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_EI = Turbine.UI.MenuItem(L["MEI"]);
opt_EI:SetChecked( ShowEquipInfos );
opt_EI.Click = function( sender, args )	ShowHideEquipInfos(); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_DI = Turbine.UI.MenuItem(L["MDI"]);
opt_DI:SetChecked( ShowDurabilityInfos );
opt_DI.Click = function( sender, args )	ShowHideDurabilityInfos(); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_PL = Turbine.UI.MenuItem(L["MPL"]);
opt_PL:SetChecked( ShowPlayerLoc );
opt_PL.Click = function( sender, args ) ShowHidePlayerLoc(); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_GT = Turbine.UI.MenuItem(L["MGT"]);
opt_GT:SetChecked( ShowGameTime );
opt_GT.Click = function( sender, args ) ShowHideGameTime(); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_options = Turbine.UI.MenuItem(L["MOP"]);
opt_options.Click = function( sender, args ) SetOptions(); opt_options:SetEnabled( false ); end

option_backcolor = Turbine.UI.MenuItem(L["MBG"]);
option_backcolor.Click = function( sender, args ) SetBackgroundColor(); option_backcolor:SetEnabled( false ); end

opt_profile = Turbine.UI.MenuItem(L["MPP"]);
opt_profile.Click = function( sender, args ) SetProfile(); opt_profile:SetEnabled( false ); end

opt_shellcmd = Turbine.UI.MenuItem(L["MSC"]);
opt_shellcmd.Click = function( sender, args ) HelpInfo(); end

local opt_ResetAllSet = Turbine.UI.MenuItem(L["MRA"]);
opt_ResetAllSet.Click = function( sender, args ) ResetSettings(); end

local opt_unload = Turbine.UI.MenuItem(L["MUTB"]);
opt_unload.Click = function( sender, args ) UnloadTitanBar(); end

local opt_reload = Turbine.UI.MenuItem(L["MRTB"]);
opt_reload.Click = function( sender, args ) ReloadTitanBar(); end

local opt_about = Turbine.UI.MenuItem(L["MATB"] .. Version);
opt_about.Click = function( sender, args ) AboutTitanBar(); end



--if PlayerAlign == 1 then TitanBarMenu.items:Add(CURMenu); end -- only show if in Free People mode
TitanBarMenu.items:Add(CURMenu);
TitanBarMenu.items:Add(opt_BI);
TitanBarMenu.items:Add(opt_PI);
if PlayerAlign == 1 then TitanBarMenu.items:Add(opt_EI); end -- only show if in Free People mode
if PlayerAlign == 1 then TitanBarMenu.items:Add(opt_DI); end -- only show if in Free People mode
TitanBarMenu.items:Add(opt_PL);
TitanBarMenu.items:Add(opt_GT);
TitanBarMenu.items:Add(opt_line);
TitanBarMenu.items:Add(opt_options);
TitanBarMenu.items:Add(option_backcolor);
TitanBarMenu.items:Add(RBCMenu);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(LocMenu);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(opt_profile);
TitanBarMenu.items:Add(opt_shellcmd);
TitanBarMenu.items:Add(opt_ResetAllSet);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(opt_unload);
TitanBarMenu.items:Add(opt_reload);
--TitanBarMenu.items:Add(opt_empty); --Add when about function in plugin manager is available
--TitanBarMenu.items:Add(opt_about); --Add when about function in plugin manager is available