-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	if GLocale == "de" then
		settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsDE" );
		pwShard, pwMark, pwMedallion, pwSeal, pwCommendation = "Scherbe", "Zeichen", "Medaillon", "Siegel", "Anerkennung";
	end
	if GLocale == "en" then
		settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsEN" );
		pwShard, pwMark, pwMedallion, pwSeal, pwCommendation = "Shard", "Mark", "Medallion", "Seal", "Commendation";
	end
	if GLocale == "fr" then
		settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsFR" );
		pwShard, pwMark, pwMedallion, pwSeal, pwCommendation = "Eclat", "Marque", "M\195\169daillon", "Sceau", "Commendation";
	end
	
	if GLocale == "en" then	tA, tR, tG, tB, tX, tY = 0.3, 0.3, 0.3, 0.3, 0, 0;
	else tA, tR, tG, tB, tX, tY = "0,3", "0,3", "0,3", "0,3", "0", "0"; end
	tL, tT = 100, 100;

	if settings == nil then	settings = {}; end
	
	if settings.TitanBar == nil then settings.TitanBar = {}; end
	if settings.TitanBar.A == nil then settings.TitanBar.A = string.format("%.3f", tA); end --Default Alpha color value
	if settings.TitanBar.R == nil then settings.TitanBar.R = string.format("%.3f", tR); end --Default Red color value
	if settings.TitanBar.G == nil then settings.TitanBar.G = string.format("%.3f", tG); end --Default Green color value
	if settings.TitanBar.B == nil then settings.TitanBar.B = string.format("%.3f", tB); end --Default Blue color value
	if settings.TitanBar.W == nil then settings.TitanBar.W = string.format("%.0f", screenWidth); end -- TitanBar Width
	if settings.TitanBar.L == nil then settings.TitanBar.L = GLocale; end -- TitanBar Language
	if settings.TitanBar.H == nil then settings.TitanBar.H = string.format("%.0f", 30); end -- TitanBar Height
	if settings.TitanBar.F == nil then settings.TitanBar.F = string.format("%.0f", 0); end -- TitanBar Font type #
	if settings.TitanBar.T == nil then settings.TitanBar.T = "Undefined"; end -- TitanBar Font name
	if settings.TitanBar.D == nil then settings.TitanBar.D = true; end -- True ->TitanBar set to Top of the screen
	bcAlpha = tonumber(settings.TitanBar.A);
	bcRed = tonumber(settings.TitanBar.R);
	bcGreen = tonumber(settings.TitanBar.G);
	bcBlue = tonumber(settings.TitanBar.B);
	TBLocale = settings.TitanBar.L;
	import (AppLocaleD..TBLocale);
	TBHeight = tonumber(settings.TitanBar.H);
	if TBHeight > 30 then CTRHeight = 30 else CTRHeight = TBHeight; end
	_G.TBFont = tonumber(settings.TitanBar.F);
	TBFontT = settings.TitanBar.T;
	local tStrS = tonumber(string.sub( TBFontT, string.len(TBFontT) - 1, string.len(TBFontT) )); --Get Font Size
	if tStrS == nil then TM = 7; else TM = ( tStrS / 2 ) + ( tStrS * 0.1 ) + 0.5; end -- Text multiplier for auto size lbl
	TBTop = settings.TitanBar.D;


	if settings.Options == nil then settings.Options = {}; end
	if settings.Options.V == nil then settings.Options.V = false; end
	if settings.Options.L == nil then settings.Options.L = string.format("%.0f", tL); end --X position of options window
	if settings.Options.T == nil then settings.Options.T = string.format("%.0f", tT); end --Y position of options window
	if settings.Options.H == nil then settings.Options.H = L["OPAHC"]; end --Auto hide option (Default is: Only in combat)
	if settings.Options.I == nil then settings.Options.I = string.format("%.0f", 32); end --Icon size (Default is: 32)
	ShowOptions = settings.Options.V;
	OPWLeft = tonumber(settings.Options.L);
	OPWTop = tonumber(settings.Options.T);
	
	TBAutoHide = settings.Options.H;
	-- If user change language, Auto hide option not showing in proper language. Fix: Re-input correct word in variable.
	if TBAutoHide == "Only in combat" or TBAutoHide == "Seulement en combat" or TBAutoHide == "Nur in der Schlacht" then TBAutoHide = L["OPAHC"]; end

	TBIconSize = settings.Options.I;
	-- If user change language, icon dissappear. Fix: Re-input correct word in variable.
	if TBIconSize == "Small (16x16)" or TBIconSize == "Petit (16x16)" or TBIconSize == "klein (16x16)" then TBIconSize = L["OPISS"];
	elseif TBIconSize == "Large (32x32)" or TBIconSize == "Grand (32x32)" or TBIconSize == "Breit (32x32)" then TBIconSize = L["OPISL"]; end

	if TBIconSize == L["OPISL"] then TBIconSize = 32; end --Old settings was Large -- Remove after Oct, 20th
	if TBIconSize == L["OPISS"] then TBIconSize = 16; end --Old settings was Small -- Remove after Oct, 20th


	if settings.Profile == nil then settings.Profile = {}; end
	if settings.Profile == false then settings.Profile = {}; end --(Remove after Oct, 9th 2012). Old Settings was: ["Profile"] = false,
	if settings.Profile.V == nil then settings.Profile.V = false; end
	if settings.Profile.L == nil then settings.Profile.L = string.format("%.0f", tL); end
	if settings.Profile.T == nil then settings.Profile.T = string.format("%.0f", tT); end
	ShowProfile = settings.Profile.V;
	PPWLeft = tonumber(settings.Profile.L);
	PPWTop = tonumber(settings.Profile.T);


	if settings.Shell == nil then settings.Shell = {}; end
	if settings.Shell.L == nil then settings.Shell.L = string.format("%.0f", tL); end --X position of Shell commands window
	if settings.Shell.T == nil then settings.Shell.T = string.format("%.0f", tT); end --Y position of Shell commands window
	SCWLeft = tonumber(settings.Shell.L);
	SCWTop = tonumber(settings.Shell.T);


	if settings.Background == nil then settings.Background = {}; end
	if settings.Background.L == nil then settings.Background.L = string.format("%.0f", tL); end --X position of Background window
	if settings.Background.T == nil then settings.Background.T = string.format("%.0f", tT); end --Y position of Background window
	BGWLeft = tonumber(settings.Background.L);
	BGWTop = tonumber(settings.Background.T);


	if settings.Money == nil then settings.Money = {}; end
	if settings.Money.V == nil then settings.Money.V = true; end
	if settings.Money.A == nil then settings.Money.A = string.format("%.3f", tA); end --Alpha color
	if settings.Money.R == nil then settings.Money.R = string.format("%.3f", tR); end --Red color
	if settings.Money.G == nil then settings.Money.G = string.format("%.3f", tG); end --Green color
	if settings.Money.B == nil then settings.Money.B = string.format("%.3f", tB); end --Blue color
	if settings.Money.X == nil then settings.Money.X = string.format("%.0f", 400); end --X position on TitanBar
	if settings.Money.Y == nil then settings.Money.Y = string.format("%.0f", tY); end --Y position on TitanBar
	if settings.Money.S == nil then settings.Money.S = false; end --Show Total Money of all character on TitanBar Money control.
	if settings.Money.L == nil then settings.Money.L = string.format("%.0f", tL); end -- X position on screen for money window
	if settings.Money.T == nil then settings.Money.T = string.format("%.0f", tT); end -- Y position on screen for money window
	ShowMoney = settings.Money.V;
	MIbcAlpha = tonumber(settings.Money.A);
	MIbcRed = tonumber(settings.Money.R);
	MIbcGreen = tonumber(settings.Money.G);
	MIbcBlue = tonumber(settings.Money.B);
	_G.MILocX = tonumber(settings.Money.X);
	_G.MILocY = tonumber(settings.Money.Y);
	_G.STM = settings.Money.S;
	MIWLeft = tonumber(settings.Money.L);
	MIWTop = tonumber(settings.Money.T);


	if settings.DestinyPoints == nil then settings.DestinyPoints = {}; end
	if settings.DestinyPoints.V == nil then settings.DestinyPoints.V = false; end
	if settings.DestinyPoints.A == nil then settings.DestinyPoints.A = string.format("%.3f", tA); end
	if settings.DestinyPoints.R == nil then settings.DestinyPoints.R = string.format("%.3f", tR); end
	if settings.DestinyPoints.G == nil then settings.DestinyPoints.G = string.format("%.3f", tG); end
	if settings.DestinyPoints.B == nil then settings.DestinyPoints.B = string.format("%.3f", tB); end
	if settings.DestinyPoints.X == nil then settings.DestinyPoints.X = string.format("%.0f", tX); end
	if settings.DestinyPoints.Y == nil then settings.DestinyPoints.Y = string.format("%.0f", tY); end
	ShowDestinyPoints = settings.DestinyPoints.V;
	DPbcAlpha = tonumber(settings.DestinyPoints.A);
	DPbcRed = tonumber(settings.DestinyPoints.R);
	DPbcGreen = tonumber(settings.DestinyPoints.G);
	DPbcBlue = tonumber(settings.DestinyPoints.B);
	_G.DPLocX = tonumber(settings.DestinyPoints.X);
	_G.DPLocY = tonumber(settings.DestinyPoints.Y);


	if settings.Shards == nil then settings.Shards = {}; end
	if settings.Shards.V == nil then settings.Shards.V = false; end
	if settings.Shards.A == nil then settings.Shards.A = string.format("%.3f", tA); end
	if settings.Shards.R == nil then settings.Shards.R = string.format("%.3f", tR); end
	if settings.Shards.G == nil then settings.Shards.G = string.format("%.3f", tG); end
	if settings.Shards.B == nil then settings.Shards.B = string.format("%.3f", tB); end
	if settings.Shards.X == nil then settings.Shards.X = string.format("%.0f", tX); end
	if settings.Shards.Y == nil then settings.Shards.Y = string.format("%.0f", tY); end
	ShowShards = settings.Shards.V;
	SPbcAlpha = tonumber(settings.Shards.A);
	SPbcRed = tonumber(settings.Shards.R);
	SPbcGreen = tonumber(settings.Shards.G);
	SPbcBlue = tonumber(settings.Shards.B);
	_G.SPLocX = tonumber(settings.Shards.X);
	_G.SPLocY = tonumber(settings.Shards.Y);
	

	if settings.SkirmishMarks == nil then settings.SkirmishMarks = {}; end
	if settings.SkirmishMarks.V == nil then settings.SkirmishMarks.V = false; end
	if settings.SkirmishMarks.A == nil then settings.SkirmishMarks.A = string.format("%.3f", tA); end
	if settings.SkirmishMarks.R == nil then settings.SkirmishMarks.R = string.format("%.3f", tR); end
	if settings.SkirmishMarks.G == nil then settings.SkirmishMarks.G = string.format("%.3f", tG); end
	if settings.SkirmishMarks.B == nil then settings.SkirmishMarks.B = string.format("%.3f", tB); end
	if settings.SkirmishMarks.X == nil then settings.SkirmishMarks.X = string.format("%.0f", tX); end
	if settings.SkirmishMarks.Y == nil then settings.SkirmishMarks.Y = string.format("%.0f", tY); end
	ShowSkirmishMarks = settings.SkirmishMarks.V;
	SMbcAlpha = tonumber(settings.SkirmishMarks.A);
	SMbcRed = tonumber(settings.SkirmishMarks.R);
	SMbcGreen = tonumber(settings.SkirmishMarks.G);
	SMbcBlue = tonumber(settings.SkirmishMarks.B);
	_G.SMLocX = tonumber(settings.SkirmishMarks.X);
	_G.SMLocY = tonumber(settings.SkirmishMarks.Y);
	

	if settings.Medallions == nil then settings.Medallions = {}; end
	if settings.Medallions.V == nil then settings.Medallions.V = false; end
	if settings.Medallions.A == nil then settings.Medallions.A = string.format("%.3f", tA); end
	if settings.Medallions.R == nil then settings.Medallions.R = string.format("%.3f", tR); end
	if settings.Medallions.G == nil then settings.Medallions.G = string.format("%.3f", tG); end
	if settings.Medallions.B == nil then settings.Medallions.B = string.format("%.3f", tB); end
	if settings.Medallions.X == nil then settings.Medallions.X = string.format("%.0f", tX); end
	if settings.Medallions.Y == nil then settings.Medallions.Y = string.format("%.0f", tY); end
	ShowMedallions = settings.Medallions.V;
	MPbcAlpha = tonumber(settings.Medallions.A);
	MPbcRed = tonumber(settings.Medallions.R);
	MPbcGreen = tonumber(settings.Medallions.G);
	MPbcBlue = tonumber(settings.Medallions.B);
	_G.MPLocX = tonumber(settings.Medallions.X);
	_G.MPLocY = tonumber(settings.Medallions.Y);


	if settings.Seals == nil then settings.Seals = {}; end
	if settings.Seals.V == nil then settings.Seals.V = false; end
	if settings.Seals.A == nil then settings.Seals.A = string.format("%.3f", tA); end
	if settings.Seals.R == nil then settings.Seals.R = string.format("%.3f", tR); end
	if settings.Seals.G == nil then settings.Seals.G = string.format("%.3f", tG); end
	if settings.Seals.B == nil then settings.Seals.B = string.format("%.3f", tB); end
	if settings.Seals.X == nil then settings.Seals.X = string.format("%.0f", tX); end
	if settings.Seals.Y == nil then settings.Seals.Y = string.format("%.0f", tY); end
	ShowSeals = settings.Seals.V;
	SLbcAlpha = tonumber(settings.Seals.A);
	SLbcRed = tonumber(settings.Seals.R);
	SLbcGreen = tonumber(settings.Seals.G);
	SLbcBlue = tonumber(settings.Seals.B);
	_G.SLLocX = tonumber(settings.Seals.X);
	_G.SLLocY = tonumber(settings.Seals.Y);


	if settings.Commendations == nil then settings.Commendations = {}; end
	if settings.Commendations.V == nil then settings.Commendations.V = false; end
	if settings.Commendations.A == nil then settings.Commendations.A = string.format("%.3f", tA); end
	if settings.Commendations.R == nil then settings.Commendations.R = string.format("%.3f", tR); end
	if settings.Commendations.G == nil then settings.Commendations.G = string.format("%.3f", tG); end
	if settings.Commendations.B == nil then settings.Commendations.B = string.format("%.3f", tB); end
	if settings.Commendations.X == nil then settings.Commendations.X = string.format("%.0f", tX); end
	if settings.Commendations.Y == nil then settings.Commendations.Y = string.format("%.0f", tY); end
	ShowCommendations = settings.Commendations.V;
	CPbcAlpha = tonumber(settings.Commendations.A);
	CPbcRed = tonumber(settings.Commendations.R);
	CPbcGreen = tonumber(settings.Commendations.G);
	CPbcBlue = tonumber(settings.Commendations.B);
	_G.CPLocX = tonumber(settings.Commendations.X);
	_G.CPLocY = tonumber(settings.Commendations.Y);
	

	if settings.BagInfos == nil then settings.BagInfos = {}; end
	if settings.BagInfos.V == nil then settings.BagInfos.V = true; end
	if settings.BagInfos.A == nil then settings.BagInfos.A = string.format("%.3f", tA); end
	if settings.BagInfos.R == nil then settings.BagInfos.R = string.format("%.3f", tR); end
	if settings.BagInfos.G == nil then settings.BagInfos.G = string.format("%.3f", tG); end
	if settings.BagInfos.B == nil then settings.BagInfos.B = string.format("%.3f", tB); end
	if settings.BagInfos.X == nil then settings.BagInfos.X = string.format("%.0f", tX); end
	if settings.BagInfos.Y == nil then settings.BagInfos.Y = string.format("%.0f", tY); end
	ShowBagInfos = settings.BagInfos.V;
	BIbcAlpha = tonumber(settings.BagInfos.A);
	BIbcRed = tonumber(settings.BagInfos.R);
	BIbcGreen = tonumber(settings.BagInfos.G);
	BIbcBlue = tonumber(settings.BagInfos.B);
	_G.BILocX = tonumber(settings.BagInfos.X);
	_G.BILocY = tonumber(settings.BagInfos.Y);


	if settings.PlayerInfos == nil then settings.PlayerInfos = {}; end
	if settings.PlayerInfos.V == nil then settings.PlayerInfos.V = false; end
	if settings.PlayerInfos.A == nil then settings.PlayerInfos.A = string.format("%.3f", tA); end
	if settings.PlayerInfos.R == nil then settings.PlayerInfos.R = string.format("%.3f", tR); end
	if settings.PlayerInfos.G == nil then settings.PlayerInfos.G = string.format("%.3f", tG); end
	if settings.PlayerInfos.B == nil then settings.PlayerInfos.B = string.format("%.3f", tB); end
	if settings.PlayerInfos.X == nil then settings.PlayerInfos.X = string.format("%.0f", 206); end
	if settings.PlayerInfos.Y == nil then settings.PlayerInfos.Y = string.format("%.0f", tY); end
	ShowPlayerInfos = settings.PlayerInfos.V;
	PIbcAlpha = tonumber(settings.PlayerInfos.A);
	PIbcRed = tonumber(settings.PlayerInfos.R);
	PIbcGreen = tonumber(settings.PlayerInfos.G);
	PIbcBlue = tonumber(settings.PlayerInfos.B);
	_G.PILocX = tonumber(settings.PlayerInfos.X);
	_G.PILocY = tonumber(settings.PlayerInfos.Y);


	if settings.EquipInfos == nil then settings.EquipInfos = {}; end
	if settings.EquipInfos.V == nil then settings.EquipInfos.V = true; end
	if settings.EquipInfos.A == nil then settings.EquipInfos.A = string.format("%.3f", tA); end
	if settings.EquipInfos.R == nil then settings.EquipInfos.R = string.format("%.3f", tR); end
	if settings.EquipInfos.G == nil then settings.EquipInfos.G = string.format("%.3f", tG); end
	if settings.EquipInfos.B == nil then settings.EquipInfos.B = string.format("%.3f", tB); end
	if settings.EquipInfos.X == nil then settings.EquipInfos.X = string.format("%.0f", 68); end
	if settings.EquipInfos.Y == nil then settings.EquipInfos.Y = string.format("%.0f", tY); end
	ShowEquipInfos = settings.EquipInfos.V;
	EIbcAlpha = tonumber(settings.EquipInfos.A);
	EIbcRed = tonumber(settings.EquipInfos.R);
	EIbcGreen = tonumber(settings.EquipInfos.G);
	EIbcBlue = tonumber(settings.EquipInfos.B);
	_G.EILocX = tonumber(settings.EquipInfos.X);
	_G.EILocY = tonumber(settings.EquipInfos.Y);


	if settings.DurabilityInfos == nil then settings.DurabilityInfos = {}; end
	if settings.DurabilityInfos.V == nil then settings.DurabilityInfos.V = true; end
	if settings.DurabilityInfos.A == nil then settings.DurabilityInfos.A = string.format("%.3f", tA); end
	if settings.DurabilityInfos.R == nil then settings.DurabilityInfos.R = string.format("%.3f", tR); end
	if settings.DurabilityInfos.G == nil then settings.DurabilityInfos.G = string.format("%.3f", tG); end
	if settings.DurabilityInfos.B == nil then settings.DurabilityInfos.B = string.format("%.3f", tB); end
	if settings.DurabilityInfos.X == nil then settings.DurabilityInfos.X = string.format("%.0f", 138); end
	if settings.DurabilityInfos.Y == nil then settings.DurabilityInfos.Y = string.format("%.0f", tY); end
	ShowDurabilityInfos = settings.DurabilityInfos.V;
	DIbcAlpha = tonumber(settings.DurabilityInfos.A);
	DIbcRed = tonumber(settings.DurabilityInfos.R);
	DIbcGreen = tonumber(settings.DurabilityInfos.G);
	DIbcBlue = tonumber(settings.DurabilityInfos.B);
	_G.DILocX = tonumber(settings.DurabilityInfos.X);
	_G.DILocY = tonumber(settings.DurabilityInfos.Y);


	if settings.PlayerLoc == nil then settings.PlayerLoc = {}; end
	if settings.PlayerLoc.V == nil then settings.PlayerLoc.V = true; end
	if settings.PlayerLoc.A == nil then settings.PlayerLoc.A = string.format("%.3f", tA); end
	if settings.PlayerLoc.R == nil then settings.PlayerLoc.R = string.format("%.3f", tR); end
	if settings.PlayerLoc.G == nil then settings.PlayerLoc.G = string.format("%.3f", tG); end
	if settings.PlayerLoc.B == nil then settings.PlayerLoc.B = string.format("%.3f", tB); end
	if settings.PlayerLoc.L == nil then settings.PlayerLoc.L = string.format( L["PLMsg"] ); end
	if settings.PlayerLoc.X == nil then settings.PlayerLoc.X = string.format("%.0f", screenWidth - 205); end
	if settings.PlayerLoc.Y == nil then settings.PlayerLoc.Y = string.format("%.0f", tY); end
	ShowPlayerLoc = settings.PlayerLoc.V;
	PLbcAlpha = tonumber(settings.PlayerLoc.A);
	PLbcRed = tonumber(settings.PlayerLoc.R);
	PLbcGreen = tonumber(settings.PlayerLoc.G);
	PLbcBlue = tonumber(settings.PlayerLoc.B);
	pLLoc = settings.PlayerLoc.L;
	_G.PLLocX = tonumber(settings.PlayerLoc.X);
	_G.PLLocY = tonumber(settings.PlayerLoc.Y);


	if settings.GameTime == nil then settings.GameTime = {}; end
	if settings.GameTime.V == nil then settings.GameTime.V = true; end
	if settings.GameTime.A == nil then settings.GameTime.A = string.format("%.3f", tA); end
	if settings.GameTime.R == nil then settings.GameTime.R = string.format("%.3f", tR); end
	if settings.GameTime.G == nil then settings.GameTime.G = string.format("%.3f", tG); end
	if settings.GameTime.B == nil then settings.GameTime.B = string.format("%.3f", tB); end
	if settings.GameTime.X == nil then settings.GameTime.X = string.format("%.0f", screenWidth - 60); end
	if settings.GameTime.Y == nil then settings.GameTime.Y = string.format("%.0f", tY); end
	if settings.GameTime.H == nil then settings.GameTime.H = false; end -- True = Show clock in 24h format
	if settings.GameTime.S == nil then settings.GameTime.S = false; end -- True = Show server time
	if settings.GameTime.O == nil then settings.GameTime.O = false; end -- True = Show both time (Server & Real)
	if settings.GameTime.M == nil then settings.GameTime.M = string.format("%.0f", 0); end -- User defined GMT
	if settings.GameTime.L == nil then settings.GameTime.L = string.format("%.0f", tL); end
	if settings.GameTime.T == nil then settings.GameTime.T = string.format("%.0f", tT); end
	ShowGameTime = settings.GameTime.V;
	GTbcAlpha = tonumber(settings.GameTime.A);
	GTbcRed = tonumber(settings.GameTime.R);
	GTbcGreen = tonumber(settings.GameTime.G);
	GTbcBlue = tonumber(settings.GameTime.B);
	_G.GTLocX = tonumber(settings.GameTime.X);
	_G.GTLocY = tonumber(settings.GameTime.Y);
	_G.Clock24h = settings.GameTime.H;
	_G.ShowST = settings.GameTime.S;
	_G.ShowBT = settings.GameTime.O;
	_G.UserGMT = settings.GameTime.M;
	GTWLeft = tonumber(settings.GameTime.L);
	GTWTop = tonumber(settings.GameTime.T);
	
	SaveSettings( false );
	
	if settings.TitanBar.W ~= screenWidth then ReplaceCtr(); end --Replace control if screenwidth as changed
end
-- **^
-- **v Save settings v**
function SaveSettings(str)
	--write("Saving settings");
	if str then --True: get all variable and save settings
		settings = {};
		--settings.Version = Version;

		settings.TitanBar = {};
		settings.TitanBar.A = string.format("%.3f", bcAlpha);
		settings.TitanBar.R = string.format("%.3f", bcRed);
		settings.TitanBar.G = string.format("%.3f", bcGreen);
		settings.TitanBar.B = string.format("%.3f", bcBlue);
		settings.TitanBar.W = string.format("%.0f", screenWidth);
		settings.TitanBar.L = TBLocale;
		settings.TitanBar.H = string.format("%.0f", TBHeight);
		settings.TitanBar.F = string.format("%.0f", _G.TBFont);
		settings.TitanBar.T = TBFontT;
		settings.TitanBar.D = TBTop;

		settings.Options = {};
		settings.Options.V = ShowOptions;
		settings.Options.L = string.format("%.0f", OPWLeft);
		settings.Options.T = string.format("%.0f", OPWTop);
		settings.Options.H = TBAutoHide;
		settings.Options.I = string.format("%.0f", TBIconSize);

		settings.Profile = {};
		settings.Profile.V = ShowProfile;
		settings.Profile.L = string.format("%.0f", PPWLeft);
		settings.Profile.T = string.format("%.0f", PPWTop);

		settings.Shell = {};
		settings.Shell.L = string.format("%.0f", SCWLeft);
		settings.Shell.T = string.format("%.0f", SCWTop);

		settings.Background = {};
		settings.Background.L = string.format("%.0f", BGWLeft);
		settings.Background.T = string.format("%.0f", BGWTop);
	
		settings.Money = {};
		settings.Money.V = ShowMoney;
		settings.Money.A = string.format("%.3f", MIbcAlpha);
		settings.Money.R = string.format("%.3f", MIbcRed);
		settings.Money.G = string.format("%.3f", MIbcGreen);
		settings.Money.B = string.format("%.3f", MIbcBlue);
		settings.Money.X = string.format("%.0f", _G.MILocX);
		settings.Money.Y = string.format("%.0f", _G.MILocY);
		settings.Money.S = _G.STM; --Show Total Money of all character on TitanBar Money control.
		if PlayerAlign == 1 then settings.Money.L = string.format("%.0f", MIWLeft); end
		if PlayerAlign == 1 then settings.Money.T = string.format("%.0f", MIWTop); end

		settings.DestinyPoints = {};
		settings.DestinyPoints.V = ShowDestinyPoints;
		settings.DestinyPoints.A = string.format("%.3f", DPbcAlpha);
		settings.DestinyPoints.R = string.format("%.3f", DPbcRed);
		settings.DestinyPoints.G = string.format("%.3f", DPbcGreen);
		settings.DestinyPoints.B = string.format("%.3f", DPbcBlue);
		settings.DestinyPoints.X = string.format("%.0f", _G.DPLocX);
		settings.DestinyPoints.Y = string.format("%.0f", _G.DPLocY);

		settings.Shards = {};
		settings.Shards.V = ShowShards;
		settings.Shards.A = string.format("%.3f", SPbcAlpha);
		settings.Shards.R = string.format("%.3f", SPbcRed);
		settings.Shards.G = string.format("%.3f", SPbcGreen);
		settings.Shards.B = string.format("%.3f", SPbcBlue);
		settings.Shards.X = string.format("%.0f", _G.SPLocX);
		settings.Shards.Y = string.format("%.0f", _G.SPLocY);

		settings.SkirmishMarks = {};
		settings.SkirmishMarks.V = ShowSkirmishMarks;
		settings.SkirmishMarks.A = string.format("%.3f", SMbcAlpha);
		settings.SkirmishMarks.R = string.format("%.3f", SMbcRed);
		settings.SkirmishMarks.G = string.format("%.3f", SMbcGreen);
		settings.SkirmishMarks.B = string.format("%.3f", SMbcBlue);
		settings.SkirmishMarks.X = string.format("%.0f", _G.SMLocX);
		settings.SkirmishMarks.Y = string.format("%.0f", _G.SMLocY);

		settings.Medallions = {};
		settings.Medallions.V = ShowMedallions;
		settings.Medallions.A = string.format("%.3f", MPbcAlpha);
		settings.Medallions.R = string.format("%.3f", MPbcRed);
		settings.Medallions.G = string.format("%.3f", MPbcGreen);
		settings.Medallions.B = string.format("%.3f", MPbcBlue);
		settings.Medallions.X = string.format("%.0f", _G.MPLocX);
		settings.Medallions.Y = string.format("%.0f", _G.MPLocY);

		settings.Seals = {};
		settings.Seals.V = ShowSeals;
		settings.Seals.A = string.format("%.3f", SLbcAlpha);
		settings.Seals.R = string.format("%.3f", SLbcRed);
		settings.Seals.G = string.format("%.3f", SLbcGreen);
		settings.Seals.B = string.format("%.3f", SLbcBlue);
		settings.Seals.X = string.format("%.0f", _G.SLLocX);
		settings.Seals.Y = string.format("%.0f", _G.SLLocY);

		settings.Commendations = {};
		settings.Commendations.V = ShowCommendations;
		settings.Commendations.A = string.format("%.3f", CPbcAlpha);
		settings.Commendations.R = string.format("%.3f", CPbcRed);
		settings.Commendations.G = string.format("%.3f", CPbcGreen);
		settings.Commendations.B = string.format("%.3f", CPbcBlue);
		settings.Commendations.X = string.format("%.0f", _G.CPLocX);
		settings.Commendations.Y = string.format("%.0f", _G.CPLocY);

		settings.BagInfos = {};
		settings.BagInfos.V = ShowBagInfos;
		settings.BagInfos.A = string.format("%.3f", BIbcAlpha);
		settings.BagInfos.R = string.format("%.3f", BIbcRed);
		settings.BagInfos.G = string.format("%.3f", BIbcGreen);
		settings.BagInfos.B = string.format("%.3f", BIbcBlue);
		settings.BagInfos.X = string.format("%.0f", _G.BILocX);
		settings.BagInfos.Y = string.format("%.0f", _G.BILocY);

		settings.PlayerInfos = {};
		settings.PlayerInfos.V = ShowPlayerInfos;
		settings.PlayerInfos.A = string.format("%.3f", PIbcAlpha);
		settings.PlayerInfos.R = string.format("%.3f", PIbcRed);
		settings.PlayerInfos.G = string.format("%.3f", PIbcGreen);
		settings.PlayerInfos.B = string.format("%.3f", PIbcBlue);
		settings.PlayerInfos.X = string.format("%.0f", _G.PILocX);
		settings.PlayerInfos.Y = string.format("%.0f", _G.PILocY);

		settings.EquipInfos = {};
		settings.EquipInfos.V = ShowEquipInfos;
		settings.EquipInfos.A = string.format("%.3f", EIbcAlpha);
		settings.EquipInfos.R = string.format("%.3f", EIbcRed);
		settings.EquipInfos.G = string.format("%.3f", EIbcGreen);
		settings.EquipInfos.B = string.format("%.3f", EIbcBlue);
		settings.EquipInfos.X = string.format("%.0f", _G.EILocX);
		settings.EquipInfos.Y = string.format("%.0f", _G.EILocY);
	
		settings.DurabilityInfos = {};
		settings.DurabilityInfos.V = ShowDurabilityInfos;
		settings.DurabilityInfos.A = string.format("%.3f", DIbcAlpha);
		settings.DurabilityInfos.R = string.format("%.3f", DIbcRed);
		settings.DurabilityInfos.G = string.format("%.3f", DIbcGreen);
		settings.DurabilityInfos.B = string.format("%.3f", DIbcBlue);
		settings.DurabilityInfos.X = string.format("%.0f", _G.DILocX);
		settings.DurabilityInfos.Y = string.format("%.0f", _G.DILocY);
	
		settings.PlayerLoc = {};
		settings.PlayerLoc.V = ShowPlayerLoc;
		settings.PlayerLoc.A = string.format("%.3f", PLbcAlpha);
		settings.PlayerLoc.R = string.format("%.3f", PLbcRed);
		settings.PlayerLoc.G = string.format("%.3f", PLbcGreen);
		settings.PlayerLoc.B = string.format("%.3f", PLbcBlue);
		settings.PlayerLoc.L = string.format( pLLoc );
		settings.PlayerLoc.X = string.format("%.0f", _G.PLLocX);
		settings.PlayerLoc.Y = string.format("%.0f", _G.PLLocY);

		settings.GameTime = {};
		settings.GameTime.V = ShowGameTime;
		settings.GameTime.A = string.format("%.3f", GTbcAlpha);
		settings.GameTime.R = string.format("%.3f", GTbcRed);
		settings.GameTime.G = string.format("%.3f", GTbcGreen);
		settings.GameTime.B = string.format("%.3f", GTbcBlue);
		settings.GameTime.X = string.format("%.0f", _G.GTLocX);
		settings.GameTime.Y = string.format("%.0f", _G.GTLocY);
		settings.GameTime.H = _G.Clock24h;
		settings.GameTime.S = _G.ShowST;
		settings.GameTime.O = _G.ShowBT;
		settings.GameTime.M = string.format("%.0f", _G.UserGMT);
		if PlayerAlign == 1 then settings.GameTime.L = string.format("%.0f", GTWLeft); end
		if PlayerAlign == 1 then  settings.GameTime.T = string.format("%.0f", GTWTop); end
	end
	
	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	write( L["TBR"] );
	TBLocale = "en";
	TBHeight = 30;
	_G.TBFont = 0;
	TBFontT = "Undefined";
	TBTop = true;

	ShowMoney, ShowDestinyPoints, ShowShards, ShowSkirmishMarks, ShowMedallions, ShowSeals, ShowCommendations, ShowBagInfos, ShowPlayerInfos, ShowEquipInfos,
	ShowDurabilityInfos, ShowPlayerLoc, ShowGameTime = true, false, false, false, false, false, false, true, false, true, true, true, true;
	_G.STM = false;
	ShowProfile = false;

	if GLocale == "en" then tA, tR, tG, tB, tX, tY = 0.3, 0.3, 0.3, 0.3, 0, 0;
	else tA, tR, tG, tB, tX, tY = "0,3", "0,3", "0,3", "0,3", "0", "0"; end
	tL, tT = 100, 100;

	bcAlpha, bcRed, bcGreen, bcBlue = tA, tR, tG, tB; --Backcolor & default X Location for TitanBar
	MIbcAlpha, MIbcRed, MIbcGreen, MIbcBlue, _G.MILocX, _G.MILocY = tA, tR, tG, tB, 400, tY; --for Money Control
	DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue, _G.DPLocX, _G.DPLocY = tA, tR, tG, tB, tX, tY; --for Destiny points Control
	SPbcAlpha, SPbcRed, SPbcGreen, SPbcBlue, _G.SPLocX, _G.SPLocY = tA, tR, tG, tB, tX, tY; --for Shards Control
	SMbcAlpha, SMbcRed, SMbcGreen, SMbcBlue, _G.SMLocX, _G.SMLocY = tA, tR, tG, tB, tX, tY; --for Skirmish marks Control
	MPbcAlpha, MPbcRed, MPbcGreen, MPbcBlue, _G.MPLocX, _G.MPLocY = tA, tR, tG, tB, tX, tY; --for Medallions Control
	CPbcAlpha, CPbcRed, CPbcGreen, CPbcBlue, _G.CPLocX, _G.CPLocY = tA, tR, tG, tB, tX, tY; --for Commendations Control
	SLbcAlpha, SLbcRed, SLbcGreen, SLbcBlue, _G.SLLocX, _G.SLLocY = tA, tR, tG, tB, tX, tY; --for Seal Control
	BIbcAlpha, BIbcRed, BIbcGreen, BIbcBlue, _G.BILocX, _G.BILocY = tA, tR, tG, tB, tX, tY; --for bag Control
	EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue, _G.EILocX, _G.EILocY = tA, tR, tG, tB, 68, tY; --for Equipement infos Control
	DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue, _G.DILocX, _G.DILocY = tA, tR, tG, tB, 138, tY; --for Durability infos Control
	PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue, _G.PILocX, _G.PILocY = tA, tR, tG, tB, 206, tY; --for Player infos Control
	
	PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue, _G.PLLocX, _G.PLLocX = tA, tR, tG, tB, screenWidth - 205, tY; --for Player Location Control
	GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue, _G.GTLocX, _G.GTLocX = tA, tR, tG, tB, screenWidth - 60, tY --for Game time Control
	_G.Clock24h = false;
	_G.ShowST = false;
	_G.ShowBT = false;

	-- Reset control that has window to default X,Y position
	OPWLeft, PPWLeft, SCWLeft, BGWLeft, MIWLeft, GTWLeft = tL, tL, tL, tL, tL, tL;
	OPWTop, PPWTop, SCWTop, BGWTop, MIWTop, GTWTop = tT, tT, tT, tT, tT, tT;
	TBAutoHide = L["OPAHC"];
	TBIconSize = 32;

	SaveSettings( true ); --True: Get & save all settings table to file. / False: only save settings table to file.
	ReloadTitanBar();
end
-- **^

function ReplaceCtr()
	--write("Screen size changed");
	local oldScreenWidth = settings.TitanBar.W;

	local oldLocX = settings.Money.X / oldScreenWidth * 100;
	_G.MILocX = oldLocX * screenWidth / 100;
	
	oldLocX = settings.DestinyPoints.X / oldScreenWidth * 100;
	_G.DPLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.Shards.X / oldScreenWidth * 100;
	_G.SPLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.SkirmishMarks.X / oldScreenWidth * 100;
	_G.SMLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.Medallions.X / oldScreenWidth * 100;
	_G.MPLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.Seals.X / oldScreenWidth * 100;
	_G.SLLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.Commendations.X / oldScreenWidth * 100;
	_G.CPLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.BagInfos.X / oldScreenWidth * 100;
	_G.BILocX = oldLocX * screenWidth / 100;

	oldLocX = settings.PlayerInfos.X / oldScreenWidth * 100;
	_G.PILocX = oldLocX * screenWidth / 100;

	oldLocX = settings.EquipInfos.X / oldScreenWidth * 100;
	_G.EILocX = oldLocX * screenWidth / 100;

	oldLocX = settings.DurabilityInfos.X / oldScreenWidth * 100;
	_G.DILocX = oldLocX * screenWidth / 100;

	oldLocX = settings.PlayerLoc.X / oldScreenWidth * 100;
	_G.PLLocX = oldLocX * screenWidth / 100;

	oldLocX = settings.GameTime.X / oldScreenWidth * 100;
	_G.GTLocX = oldLocX * screenWidth / 100;
	
	SaveSettings( true );
end